#include<bits/stdc++.h>
#define MAXN 2000007
using namespace std;

long long ans;

int n,pref[MAXN],val[MAXN];
char text[MAXN];

stack<int> st;

pair<int,int> tree[4*MAXN];
int lazy[4*MAXN];

void psh(int v){
    if(lazy[v]==0)return;

    tree[2*v].first+=lazy[v];
    tree[2*v+1].first+=lazy[v];

    tree[2*v].second+=lazy[v];
    tree[2*v+1].second+=lazy[v];

    lazy[2*v]+=lazy[v];
    lazy[2*v+1]+=lazy[v];

    lazy[v]=0;
}

void update(int v,int l,int r,int ll,int rr){
    if(ll>rr)return;

    if(l==ll and r==rr){
        tree[v].first--;
        tree[v].second--;
        lazy[v]--;
    }else{
        psh(v);

        int tt=(l+r)/2;
        update(2*v,l,tt,ll,min(tt,rr));
        update(2*v+1,tt+1,r,max(tt+1,ll),rr);

        tree[v].first=min(tree[2*v].first,tree[2*v+1].first);
        tree[v].second=max(tree[2*v].second,tree[2*v+1].second);
    }
}

int query(int v,int l,int r,int ll,int rr,int val){
    if(ll>rr)return 0;
    if(l==ll and r==rr and tree[v].first>=val)return r-l+1;
    if(l==ll and r==rr and tree[v].second<val)return 0;

    psh(v);
    int tt=(l+r)/2;
    return query(2*v,l,tt,ll,min(tt,rr),val) + query(2*v+1,tt+1,r,max(tt+1,ll),rr,val);
}

int main(){
    
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>(text+1);

    for(int i=1;i<=n;i++){
        if(text[i]=='(')pref[i]=1;
        else pref[i]=-1;

        pref[i]+=pref[i-1];
    }

    for(int i=n;i>=1;i--){
        if(text[i]==')'){
            if(st.empty())update(1,1,n,i,n);
            else{
                update(1,1,n,i,st.top()-1);
                st.pop();
            }
        }else{
            st.push(i);
        }

        ans+=query(1,1,n,i,n,-pref[i-1]);
    }

    cout<<ans<<"\n";

    return 0;
}
