#include "intervals.h"
#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
using namespace std;
const int MAXN=5e3+10;
bool fl[MAXN];
int t[MAXN][MAXN], ss[MAXN];
int getl(int i, int j) {
    if (i>j) swap(i,j);
    return t[i][j];
}
vector <int> max_cardinality_intersection (int n) {
    vector <int> v, ans;
    vector <pair <int,int> >curv;
    ans.push_back(0);
    memset(t,-1,sizeof(t));
    for (int i=0;i+1<n;i++) {
        for (int j=i+1;j<n;j++) {
            int cur=length_intersection({i,j});
            t[i][j]=cur;
        }
    }
    for (int i=0;i<n;i++) ss[i]=length_intersection({i});
    for (int i=0;i<n;i++) {
        curv.clear();
        for (int j=0;j<n;j++) {
            if (j==i) continue;
            int cur=getl(i,j);
            if (cur>0 && (cur!=ss[j] || (ss[j]==ss[i] && i<j))) curv.push_back({cur,j});
            fl[j]=false;
        }
        sort(curv.begin(),curv.end());
        for (auto j:curv) {
            if (fl[j.second]) continue;
            v.clear();
            v.push_back(i); v.push_back(j.second);
            for (int k=0;k<n;k++) {
                if (k==i || k==j.second) continue;
                int s1, s2;
                s1=getl(i,k);
                s2=getl(k,j.second);
                if (s1>0 && s2>0 && (s1<j.first || s2<j.first)) {
                    fl[j.second]=true;
                    break;
                }
                if (s1==0 || s2==0) continue;
                v.push_back(k);
            }
            if (!fl[j.second] && v.size()>ans.size()) {
                ans.clear();
                for (auto i:v) ans.push_back(i);
            }
        }
    }
    return ans;
}
