#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 4e6 + 10;
int n;
string s;
int pref[maxn], lc[maxn], rc[maxn];
int rev[maxn];
/// left_border[maxn], right_border[maxn];

/**int fun(int l, int r)
{
    if (l > r)
        return -1;

    int m = l;
    for (int i = l + 1; i <= r; i ++)
        if (rev[i] < rev[m])
        m = i;

    lc[m] = fun(l, m - 1);
    rc[m] = fun(m + 1, r);
    left_border[m] = l;
    right_border[m] = r;
    return m;
}*/

int root;
void build_cartesian()
{
    stack < int > st;
    for (int i = 1; i <= n; i ++)
    {
        lc[i] = -1;
        while(!st.empty() && rev[st.top()] >= rev[i])
        {
            lc[i] = st.top();
            st.pop();
        }
        st.push(i);
    }


    while(!st.empty())
    {
        root = st.top();
        st.pop();
    }

    //cout << "here " << root << endl;
    //for (int i = 1; i <= n; i ++)
    //  cout << lc[i]

    ///exit(0);
    for (int i = n; i > 0; i --)
    {
        rc[i] = -1;
        while(!st.empty() && rev[st.top()] > rev[i])
        {
            rc[i] = st.top();
            st.pop();
        }
        st.push(i);
    }

    /***cout << "root " << root << endl;
    for (int i = 1; i <= n; i ++)
    {
        cout << "index " << i << " value: " << rev[i] << " " << lc[i] << " " << rc[i] << endl;
    }*/


    ///root = fun(1, n);
}

struct task
{
    int type, val;

    task(int _type = 0, int _val = 0)
    {

        type = _type;
        val = _val;
    }
};

ll ans = 0;
vector < task > spot[2][maxn];
void dfs(int ver, int left, int right)
{
    if (ver == -1)
        return;
    if (ver - left < right - ver)
    {
        for (int l = left; l <= ver; l ++)
        {
            spot[0][ver].push_back(task(1, rev[ver] + pref[l - 1]));
            spot[0][right + 1].push_back(task(-1, rev[ver] + pref[l - 1]));
        }
    }
    else
    {
        for (int r = ver; r <= right; r ++)
        {
            spot[1][ver].push_back(task(1, rev[r + 1] - rev[ver]));
            spot[1][left - 1].push_back(task(-1, rev[r + 1] - rev[ver]));
        }
    }
    /**for (int l = left; l <= ver; l ++)
        for (int r = ver; r <= right; r ++)
    {
        /// pref[l - 1] >= rev[r + 1] - rev[ver]
        /// rev[r + 1]
        if (rev[ver] - rev[r + 1] + pref[l - 1] >= 0)
            ans ++;
    }*/

    dfs(lc[ver], left, ver - 1);
    dfs(rc[ver], ver + 1, right);
}

int fen[2 * maxn];

void update(int pos, int val)
{
    pos += n;
    for (int i = pos; i <= 2 * n; i += (i & -i))
        fen[i] += val;
}

int sum(int pos)
{
    pos += n;
    int s = 0;
    for (int i = pos; i > 0; i -= (i & -i))
        s += fen[i];
    return s;
}

void solve()
{
    cin >> n >> s;
    s = "#" + s;
    for (int i = 1; i <= n; i ++)
    {
        pref[i] = pref[i - 1];
        if (s[i] == '(')
            pref[i] ++;
        else
            pref[i] --;
    }
    for (int i = n; i > 0; i --)
    {
        rev[i] = rev[i + 1];
        if (s[i] == '(')
            rev[i] ++;
        else
            rev[i] --;
    }


    build_cartesian();
    dfs(root, 1, n);

    for (int i = 1; i <= n; i ++)
    {
        update(pref[i - 1], 1);
        for (task cur : spot[1][i])
        {
            ans = ans + (ll)cur.type * (ll)(i - sum(cur.val - 1));
        }

    }

    for (int i = 1; i <= 2 * n; i ++)
        fen[i] = 0;

    for (int i = n; i > 0; i --)
    {
        update(rev[i + 1], 1);
        for (task cur : spot[0][i])
        {
            ans = ans + (ll)(cur.type) * (ll)(sum(cur.val));
        }
    }

    cout << ans << endl;

}

int main()
{
    speed();
    solve();
    return 0;
}
