#include<bits/stdc++.h>
#include "intervals.h"

using namespace std;


const int maxn = 5010;
vector < int > st[maxn];
vector < int > adj[maxn];
int used[maxn], len[maxn], par[maxn];
int inter[maxn][maxn];

deque < int > find_order(vector < int > top_layer)
{
    deque < int > temp;

    temp.push_back(top_layer[0]);

    top_layer.erase(top_layer.begin());

    while(!top_layer.empty())
    {
        int mx = - 1, best = -1;
        int lf = temp[0], rf = temp[(int)(temp.size()) - 1];
        for (int i = 0; i < top_layer.size(); i ++)
        {
            int cur = top_layer[i];
            if (inter[cur][lf] == 0 && inter[cur][rf] == 0)
                continue;
            if (inter[cur][lf] > inter[cur][rf])
            {
                if (mx == -1 || inter[cur][lf] > inter[mx][best])
                {
                    mx = i;
                    best = lf;
                }
            }
            else
            {
                if (mx == -1 || inter[cur][rf] > inter[mx][best])
                {
                    mx = i;
                    best = rf;
                }
            }
        }

        if (mx == -1)
            break;

        if (best == lf)
        {
            temp.push_front(top_layer[mx]);
        }
        else
        {
            temp.push_back(top_layer[mx]);
        }

        top_layer.erase(top_layer.begin() + mx);

    }

    deque < int > so_far = temp;
    if (!top_layer.empty())
    {

        deque < int > add = find_order(top_layer);
        for (int cur : add)
            so_far.push_back(cur);
    }
    return so_far;
}

int l[maxn], r[maxn];
vector < int > max_cardinality_layer(vector < int > layer)
{
    deque < int > ord = find_order(layer);
    vector < int > max_car;
    for (int cur : ord)
    {
        vector < int > sub = st[cur];

        int i = 0;
        while(sub[i] != cur)
            i ++;
        sub.erase(sub.begin() + i);

        vector < int > under;
        if (sub.size() > 0)
            under = max_cardinality_layer(sub);
        under.push_back(cur);
        if (under.size() > max_car.size())
            swap(under, max_car);
    }


    int last = -1;
    vector < int > imp;
    for (int cur : ord)
        imp.push_back(cur);

    while(!ord.empty())
    {
        int fr = ord.front();
        ord.pop_front();

        int len_lf = 0, len_rf = 0, len_uni = 0;

        if (last != -1)
            len_lf = inter[last][fr];
        if (!ord.empty())
            len_rf = inter[fr][ord[0]];

        if (last != -1 && !ord.empty())
            len_uni = inter[last][ord[0]];

        if (len_lf == 0)
        {
            if (last == -1)
                l[fr] = 1;
            else
                l[fr] = r[last] + 1;
        }

        if (len_lf == 0 && len_rf == 0 && len_uni == 0)
            r[fr] = l[fr] + 1;
        else if (len_uni == 0)
        {
            r[fr] = l[fr] + len_lf + len_rf + 1;
        }
        else
        {
            r[fr] = l[fr] + len_lf + len_rf - len_uni;
        }

        for (int cur : st[fr])
        {
            if (cur == fr)
                continue;

            if (last == -1 || inter[last])
            {

            }
        }


        last = fr;
    }
    /**for (int cur : ord)
        cout << cur << " ";
    cout << endl;*/
    exit(0);
}


vector<int> max_cardinality_intersection(int n)
{
    for (int i = 0; i < n; i ++)
    {
        st[i].push_back(i);
        len[i] = length_intersection({i});
    }


    vector < int > res;
    for (int step = 1; step <= 100; step ++)
    {
        for (int i = 0; i < n; i ++)
            used[i] = 0;
        int v = rand() % n;
        vector < int > idc;
        idc.push_back(v);
        used[v] = 1;
        vector < int > vec;
        for (int i = 0; i < n; i ++)
        {
            if (i != v)
                vec.push_back(i);
        }
        random_shuffle(vec.begin(), vec.end());
        while(true)
        {

            int mx = -1, best = -1;
            for (int i = 0; i < vec.size(); i ++)
            {
                if (!used[vec[i]])
                {

                    idc.push_back(vec[i]);
                    int val = length_intersection(idc);
                    if (val != 0 && mx == -1)
                    {
                        best = val;
                        mx = vec[i];
                        idc.pop_back();
                        break;
                    }
                    idc.pop_back();
                }
            }

            if (mx == -1)
            {
                if (idc.size() > res.size())
                    swap(res, idc);
                break;
            }
            idc.push_back(mx);
            used[mx] = 1;
        }
    }
    return res;
}
