#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
int n;
bool Exit[500010];
vector<int> g[500010];
int par[500010];
pair<int,int> minDist[500010];
pair<int,int> up[500010];
int distSubtree[500010];
int t,intime[500010],outtime[500010];
bool isParent(int u,int v){
    return (intime[u]<=intime[v] && outtime[u]>=outtime[v]);
}
void bfs(){
    queue<int> q;
    for(int i=0;i<n;i++){
        if(Exit[i]){
            q.push(i);
            minDist[i]={0,i};
        }
        else minDist[i]={1e9,-1};
    }
    while(!q.empty()){
        int u=q.front();
        q.pop();
        for(auto v: g[u]){
            if(minDist[v].first>minDist[u].first+1){
                minDist[v]={minDist[u].first+1,minDist[u].second};
                q.push(v);
            }
        }
    }
}
void dfs1(int u,int p){
    par[u]=p;
    intime[u]=t++;
    for(auto v: g[u]){
        if(v==p) continue;
        dfs1(v,u);
        distSubtree[u]=min(distSubtree[v]+1,distSubtree[u]);
    }
    outtime[u]=t++;
}
void dfs2(int u,int p){
    for(auto v: g[u]){
        if(v==p) continue;
        if(distSubtree[v]>=1e9) up[v]={up[u].first+1,up[u].second};
        else up[v]={0,v};
        dfs2(v,u);
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin>>n>>q;
    for(int i=0;i<n;i++){
        cin>>Exit[i];
        if(!Exit[i]) distSubtree[i]=1e9;
    }
    for(int i=0;i<n-1;i++){
        int u,v;
        cin>>u>>v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    bfs();
    dfs1(0,-1);
    dfs2(0,-1);
    /*for(int i=0;i<n;i++){
        cout<<i+1<<":   "<<minDist[i].first<<" "<<minDist[i].second+1<<"     "<<distSubtree[i]<<"   "<<up[i].first<<" "<<up[i].second+1<<endl;
    }
    cout<<endl;*/
    int u,v;
    cin>>u>>v;
    u--;
    v--;
    int x=0,ans=1e9;
    if(intime[u]>intime[v]) swap(u,v);
    while(!isParent(u,v)){
        //cout<<u+1<<" "<<v+1<<endl;
        ans=min(ans,max(minDist[u].first,distSubtree[v])+x);
        //cout<<max(minDist[u].first,distSubtree[v])+x<<endl;
        ans=min(ans,max(minDist[v].first,distSubtree[u])+x);
        //cout<<max(minDist[v].first,distSubtree[u])+x<<endl;
        u=par[u];
        v=par[v];
        x+=2;
        if(intime[u]>intime[v]) swap(u,v);
    }
    while(u!=v){
        //cout<<u+1<<" "<<v+1<<endl;
        int mem;
        for(auto e: g[u]){
            if(e==par[u]) continue;
            if(isParent(e,v)){
                mem=e;
                continue;
            }
            ans=min(ans,max(minDist[v].first,distSubtree[e]+1)+x);
            //cout<<max(minDist[v].first,distSubtree[e]+1)+x<<endl;
        }
        u=mem;
        x++;
    }
    cout<<ans;
    return 0;
}

