#include "intervals.h"
///#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#include <random>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

int n0;
vector<int> ans;
vector< vector<int> > cliques[MAXN + 5];

int length_intersection(vector<int> indices);

vector<int> max_cardinality_intersection(int n)
{
    n0 = n;

    for (int i = 0; i < n; ++ i)
    {
        cliques[1].push_back({i});
    }

    ans = {0};
    for (int t = 2; t <= n; ++ t)
    {
        for (auto v : cliques[t - 1])
        {
            int cnt = 0;
            for (int i = v.back() + 1; i < n0; ++ i)
            {
                auto v2 = v;
                cnt++;
                v2.push_back(i);
                if (length_intersection(v2) > 0) cliques[t].push_back(v2);
                if (cnt > 20) break;
            }
            if (cliques[t].size() > n0 * n0) break;
        }
        if (!cliques[t].empty()) ans = cliques[t][0];
    }
    return ans;
}
