#include "intervals.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 5005;

int dp[maxn];
vector<int> which[maxn];

vector<int> max_cardinality_intersection(int n)
{
    int ans = 1;

    for (int i = 0; i < n; ++i)
    {
        dp[i] = 1;
        which[i].push_back(i);

        for (int j = i - 1; j >= 0; --j)
        {
            vector<int> v;
            v = which[j]; v.push_back(i);

            if (length_intersection(v) > 0)
            {
                if (dp[i] < 1 + dp[j])
                {
                    dp[i] = dp[j] + 1;
                    which[i] = v;
                }
            }
        }

        ans = max(ans, dp[i]);
    }

    if (ans == 1) cout << 1/0 << endl;

    for (int i = 0; i < n; ++i)
    {
        if (dp[i] == ans)
        {
            return which[i];
        }
    }
}
