#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

const int inf=1e9+7;

int n,t,a,b,ans,sz;
int e[MAXN],dist[MAXN];
vector<int> v[MAXN],path;

int pref[MAXN],suff[MAXN];
bool li[MAXN];
queue<int> q;

void bfs(int x){
    for(int i=0;i<v[x].size();i++){
        if(li[v[x][i]])continue;

        dist[v[x][i]]=dist[x]+1;
        li[v[x][i]]=true;

        q.push(v[x][i]);
    }
}

bool dfs(int x,int p,int y){
    if(x==y){
        path.push_back(y);
        return true;
    }

    for(int i=0;i<v[x].size();i++){
        if(v[x][i]==p)continue;

        if(dfs(v[x][i],x,y)){
            path.push_back(x);
            return true;
        }
    }

    return false;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>t;
    for(int i=1;i<=n;i++){
        cin>>e[i];
        if(e[i]==1){
            li[i]=true;
            q.push(i);
        }
    }

    for(int i=1;i<=n-1;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    while(!q.empty()){
        bfs(q.front());
        q.pop();
    }

    for(int i=1;i<=t;i++){
        cin>>a>>b;

        path.clear();
        dfs(a,0,b);
        reverse(path.begin(),path.end());

        for(int f=0;f<path.size();f++){
            pref[f]=inf;

            if(e[path[f]])pref[f]=1;

            for(int k:v[path[f]]){
                if(f+1<path.size() and k==path[f+1])continue;

                if(dist[k]==dist[path[f]]-1)pref[f]=1;
            }
        }

        for(int f=path.size()-1;f>=0;f--){
            suff[f]=inf;

            if(e[path[f]])suff[f]=1;
            for(int k:v[path[f]]){
                if(f-1>=0 and k==path[f-1])continue;

                if(dist[k]==dist[path[f]]-1)suff[f]=1;
            }

        }

        ans=inf; sz=int(path.size());
        for(int f=0;f<path.size();f++){
            for(int k=f;k<path.size();k++){
                if(pref[f]==1 and suff[k]==1)ans=min(ans, min( f+max(dist[path[f]],sz-k-1+dist[path[k]]) , sz-k-1+max(dist[path[k]],f+dist[path[f]])  )  );
            }
        }

        cout<<ans<<"\n";
    }


    return 0;
}

