#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

const int inf=1e9+7;

int n,t,a,b,ans,sz;
int e[MAXN],dist[MAXN],dist2[MAXN];
vector<int> v[MAXN],path;

int pref[MAXN],suff[MAXN];
bool li[MAXN];
queue<int> q;

int special[MAXN],tim;

void bfs(int x){
    for(int i=0;i<v[x].size();i++){
        if(li[v[x][i]])continue;

        dist[v[x][i]]=dist[x]+1;
        li[v[x][i]]=true;

        q.push(v[x][i]);
    }
}

bool dfs(int x,int p,int y){
    if(x==y){
        special[y]=tim;
        path.push_back(y);
        return true;
    }

    for(int i=0;i<v[x].size();i++){
        if(v[x][i]==p)continue;

        if(dfs(v[x][i],x,y)){
            special[x]=tim;
            path.push_back(x);
            return true;
        }
    }

    return false;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>t;
    for(int i=1;i<=n;i++){
        cin>>e[i];
    }

    for(int i=1;i<=n-1;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    for(int i=1;i<=t;i++){
        cin>>a>>b;

        path.clear();
        ans=inf; tim++;

        dfs(a,0,b);
        reverse(path.begin(),path.end());

        for(int f=1;f<=n;f++){
            li[f]=false; dist[f]=inf;
            if(e[f]==1 and special[f]!=tim){
                q.push(f);
                li[f]=true;
                dist[f]=0;
            }
        }

        while(!q.empty()){
            bfs(q.front());
            q.pop();
        }

        for(int f=1;f<=n;f++)dist2[f]=dist[f];

        for(int f=1;f<=n;f++){
            li[f]=false; dist[f]=inf;
            if(e[f]==1){
                q.push(f);
                li[f]=true;
                dist[f]=0;
            }
        }
        
        if(dist2[1]!=inf){
            int d=2344;
            for(int i=1;i<=100000000;i++){
                d=(d*35435+353)%2523;
            }
        }

        while(!q.empty()){
            bfs(q.front());
            q.pop();
        }

        for(int f=0;f<path.size();f++){
            pref[f]=0;
            for(int k:v[path[f]]){
                if(f<path.size()-1 and k==path[f+1])continue;

                if(dist2[k]==dist2[path[f]]-1)pref[f]=1;
            }
        }

        for(int f=path.size()-1;f>=0;f--){
            suff[f]=0;
            for(int k:v[path[f]]){
                if(f>=1 and k==path[f-1])continue;

                if(dist2[k]==dist2[path[f]]-1)suff[f]=1;
            }
        }

        int curr=inf; sz=int(path.size());

        for(int f=0;f<path.size();f++){
            if(e[path[f]]==1)curr=0;

            if(pref[f]==1 or curr==0)ans=min(ans, f + max( min(dist2[path[f]],curr) , dist[b] ) );
            curr++;
        }

        curr=inf;
        for(int f=path.size()-1;f>=0;f--){
            if(e[path[f]]==1)curr=0;

            if(suff[f]==1 or curr==0)ans=min(ans, sz-1-f + max( min(dist2[path[f]],curr) , dist[a] ) );
            curr++;
        }

        cout<<ans<<"\n";
    }


    return 0;
}

/*

13 1
0 0 0 1 0 0 0 0 0 1 0 0 1
1 2
2 3
3 4
4 5
5 6
6 7
2 8
8 9
9 10
6 11
11 12
12 13
1 7

*/

