/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ustata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include "intervals.h"
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <random>
#include <bitset>
#include <chrono>
#include <ctime>
#include <stack>
#include <queue>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 5000 + 10;
const int INF  = 1e9;

std::bitset <MAXN> bs[MAXN];
bool queried[MAXN][MAXN];
std::mt19937 rng(123457); //std::chrono::steady_clock::now().time_since_epoch().count());
std::vector <int> max_cardinality_intersection(int n)
{
    double begTime = clock();
    if (n == 1)
    {
        return {0};
    }

    int max = 1;
    std::vector <int> ans; 
    std::vector <int> perm(n);
    // std::vector <int> cnt(n, 0);
    std::iota(perm.begin(), perm.end(), 0);

    for (int idxOne = 0 ; idxOne < n ; ++idxOne)
    {
        for (int idxTwo = idxOne + 1 ; idxTwo < n ; ++idxTwo)
        {
            if (length_intersection({idxOne, idxTwo}) == 0)
            {
                bs[idxOne][idxTwo] = 1;
                bs[idxTwo][idxOne] = 1;
            }
        }
    }

    std::bitset <MAXN> currBs;
    while ((clock() - begTime) / CLOCKS_PER_SEC < 1.9)
    {
        if (n <= 100 && ((clock() - begTime) / CLOCKS_PER_SEC > 0.5))
        {
            break;
        }
        
        currBs.set();
        std::vector <int> curr;
        std::shuffle(perm.begin(), perm.end(), rng);
        for (int j = 0 ; j < n ; ++j)
        {
            if (currBs.count() + curr.size() < ans.size())
            {
                break;
            }

            if (!currBs[perm[j]])
            {
                continue;
            }

            curr.push_back(perm[j]);
            if (j > 0 && length_intersection(curr) == 0)
            {
                curr.pop_back();
            } else
            {
                // cnt[perm[j]]++;
                currBs ^= (currBs & bs[curr.back()]);
                currBs[perm[j]] = 0;
            }
        }

        if (curr.size() > ans.size())
        {
            ans = curr;
        }
    }   

    return ans;
}