/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ustata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 500000 + 10;
const int INF  = 1e9;

int n, q;
int x, y;
int par[MAXN];
int dep[MAXN];
int parent[MAXN];
std::vector <int> g[MAXN];
bool isExit[MAXN];

int closestToX;
void dfsX(int node, int p)
{
    par[node] = p;
    dep[node] = dep[p] + 1;
    if (isExit[node])
    {
        closestToX = std::min(closestToX, dep[node]);
    }

    for (const int &u : g[node])
    {
        if (u == p)
        {
            continue;
        }
        
        dfsX(u, node);
    }
}

int ans;
void dfsY(int node, int p, int acc, int dist)
{
    if (isExit[node])
    {
        ans = std::min(ans, acc + std::max(closestToX, dist - acc));
    }

    for (const int &u : g[node])
    {
        if (u == p)
        {
            continue;
        }

        if (u == par[node])
        {
            dfsY(u, node, acc + 1, dist + 1);
        } else
        {
            dfsY(u, node, acc, dist + 1);
        }
    }
}

int solve()
{
    closestToX = n;
    dep[0] = -1;
    dfsX(x, 0);
    ans = 2 * n;
    dfsY(y, 0, 0, 0);
    return ans;
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> isExit[i];
    }

    for (int i = 1 ; i < n ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    std::cin >> x >> y;
}

void fastIOI()
{ 
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    int res = solve();
    std::swap(x, y);
    res = std::min(res, solve());
    std::cout << res << '\n';

    return 0;
}