#include <iostream>
#include <vector>
#include <stack>
using namespace std;
const int MAXN=5e5+10;
bool isOut[MAXN], used[MAXN], inPath[MAXN];
int arr[MAXN], dp[MAXN];
vector <int> v[MAXN], path;
void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
void find_path(int a, int b) {
    stack <int> st;
    st.push(a);
    used[a]=true;
    while (!st.empty()) {
        int x=st.top();
        if (x==b) break;
        used[x]=true;
        if (arr[x]==v[x].size()) {
            st.pop();
            continue;
        }
        while (arr[x]<v[x].size()) {
            int i=v[x][arr[x]];
            arr[x]++;
            if (!used[i]) {
                st.push(i);
                break;
            }
        }
    }
    while (!st.empty()) {
        path.push_back(st.top());
        inPath[st.top()]=true;
        st.pop();
    }
}
int find_dp(int x, int p) {
    if (isOut[x]) return dp[x]=0;
    dp[x]=MAXN;
    for (auto i:v[x]) {
        if (i==p || inPath[i]) continue;
        dp[x]=min(dp[x],find_dp(i,x)+1);
    }
    return dp[x];
}
void solve() {
    int len=0, ans=MAXN, mins=MAXN, ss=path.size()-1;
    for (auto i:path) {
        int cur=find_dp(i,-1);
        mins=min(mins,cur+len);
        ans=min(ans,ss-len+max(mins,cur));
        len++;
    }
    cout << ans << endl;
}
int main () {
    fastIO();
    int n, q;
    cin >> n >> q;
    for (int i=1;i<=n;i++) cin >> isOut[i];
    int a, b;
    for (int i=0;i<n-1;i++) {
        cin >> a >> b;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    cin >> a >> b;
    find_path(a,b);
    solve();
    return 0;
}
/*
10 3
0 1 0 1 0 1 0 1 0
0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
3 10
*/
