#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 4e6 + 10;
int n;
string s;
int pref[maxn], lc[maxn], rc[maxn];
int rev[maxn], left_border[maxn], right_border[maxn];

int fun(int l, int r)
{
    if (l > r)
        return -1;

    int m = l;
    for (int i = l + 1; i <= r; i ++)
        if (rev[i] < rev[m])
        m = i;

    lc[m] = fun(l, m - 1);
    rc[m] = fun(m + 1, r);
    left_border[m] = l;
    right_border[m] = r;
    return m;
}

int root;
void build_cartesian()
{
    root = fun(1, n);
}

ll ans = 0;
void dfs(int ver)
{
    if (ver == -1)
        return;
    for (int l = left_border[ver]; l <= ver; l ++)
        for (int r = ver; r <= right_border[ver]; r ++)
    {
        if (rev[ver] - rev[r + 1] + pref[l - 1] >= 0)
            ans ++;
    }

    dfs(lc[ver]);
    dfs(rc[ver]);
}
void solve()
{
    cin >> n >> s;
    s = "#" + s;
    for (int i = 1; i <= n; i ++)
    {
        pref[i] = pref[i - 1];
        if (s[i] == '(')
                pref[i] ++;
        else
            pref[i] --;
    }
    for (int i = n; i > 0; i --)
    {
        rev[i] = rev[i + 1];
        if (s[i] == '(')
                rev[i] ++;
        else
            rev[i] --;
    }


    build_cartesian();
    dfs(root);


    cout << ans << endl;

}

int main()
{
    speed();
    solve();
    return 0;
}
