#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=5e5+5;
const int INF=1e9;

typedef pair<int,int> pii;

int n,q;
bool ex[MAXN];
vector<int> adj[MAXN];
int d[MAXN];
bool mark[MAXN];
int x,y;
vector<pii> pos;
int prefT[MAXN];
int suffT[MAXN];
int prefH[MAXN];
int ans;

void dfs1(int v,int par,int depth)
{
    if(v==y) mark[v]=1;
    d[v]=depth;
    for(auto u: adj[v])
    {
        if(u==par) continue;
        dfs1(u,v,depth+1);
        if(mark[u]) mark[v]=1;
    }
}

void dfs2(int v,int par,int minD,int dist)
{
    if(ex[v]) pos.push_back({dist,max(0,d[y]-minD)});
    for(auto u: adj[v])
    {
        if(u==par) continue;
        dfs2(u,v,min(minD,d[u]),dist+1);
    }
}

int bs(int val)
{
    int l=0,r=pos.size()-1;
    while(l<r)
    {
        int mid=(l+r)/2;
        if((pos[mid].fi-pos[mid].se)>=val) r=mid;
        else l=mid+1;
    }
    if(pos[l].fi-pos[l].se>=val) return l;
    else return pos.size();
}

void dfs3(int v,int par,int r)
{
    if(ex[v])
    {
        int ind=bs(d[v]);
        if(ind<pos.size()) ans=min(ans, suffT[ind]);
        if(ind>0)
        {
            if(prefT[ind-1]<=d[v]-r) ans=min(ans,d[v]);
            else ans=min(ans, min(prefT[ind-1]+r, prefH[ind-1]+d[v]));
        }
        //cout<<v<<" "<<d[v]<<" "<<ind<<" "<<pref[ind]<<endl;
    }
    for(auto u: adj[v])
    {
        if(u==par) continue;
        int newr=r;
        if(mark[u]) newr=d[u];
        dfs3(u,v,newr);
    }
}

bool cmp(pii a, pii b)
{
    return (a.fi-a.se)<(b.fi-b.se);
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>q;
for(int i=1;i<=n;i++)
{
    cin>>ex[i]; ///
}
for(int i=1;i<n;i++)
{
    int u,v;
    cin>>u>>v;
    adj[u].push_back(v);
    adj[v].push_back(u);
}

for(int i=0;i<q;i++)
{
    cin>>x>>y;
    if(n==1)
    {
        cout<<0<<endl;
        continue;
    }
    if(ex[y]) swap(x,y);
    if(ex[x] && ex[y])
    {
        cout<<0<<endl;
        continue;
    }

    dfs1(x,-1,0);

    dfs2(y,-1,d[y],0);

    sort(pos.begin(), pos.end(), cmp);

    prefT[0]=pos[0].fi;
    for(int i=1;i<pos.size();i++) prefT[i]=min(prefT[i-1],pos[i].fi);
    suffT[pos.size()-1]=pos[pos.size()-1].fi;
    for(int i=pos.size()-2;i>=0;i--) suffT[i]=min(suffT[i+1],pos[i+1].fi);
    prefH[0]=pos[0].se;
    for(int i=1;i<pos.size();i++) prefH[i]=min(prefH[i-1],pos[i].se);

    //for(auto t: pos) cout<<t.fi<<" "<<t.se<<" ; "; cout<<endl;

    if(ex[x])
    {
        cout<<prefT[pos.size()-1]<<endl;
        continue;
    }

    ans=INF;
    dfs3(x,-1,0);

    cout<<ans<<endl;
}

return 0;
}
/*
10 1
0 0 0 0 0 0 0 0 1 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
8 1
*/
