#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 1e5+5;

int n,q,e[maxn];
vector<int>v,g[maxn];

int sub[maxn],jump[maxn][20];

int lca(int a, int b)
{
    if(sub[a]<sub[b]) swap(a,b);
    int raz = sub[a]-sub[b];
    for(int i = 19; i >= 0; i--) if(raz&(1<<i)) a = jump[a][i];
    if(a==b) return a;
    for(int i = 19; i >= 0; i--)
    {
        if(jump[a][i]!=jump[b][i])
        {
            a = jump[a][i];
            b = jump[b][i];
        }
    }
    return jump[a][0];
}

void dfs_sub(int beg, int p)
{
    sub[beg] = sub[p] + 1;
    jump[beg][0] = p;
    for(int nb : g[beg]) if(nb!=p) dfs_sub(nb,beg);
}

void pre()
{
    dfs_sub(1,1);
    for(int j = 1; j < 20; j++)
    {
        for(int i = 1; i <= n; i++)
        {
            jump[i][j] = jump[jump[i][j-1]][j-1];
        }
    }
}

int par[maxn],cel,idx;
vector<int>path[2];

void dfs(int beg)
{
    if(beg==cel)
    {
        path[idx].clear();
        for(; par[beg] != beg; beg = par[beg]) path[idx].push_back(beg);
        path[idx].push_back(beg);
        reverse(path[idx].begin(),path[idx].end());
        return;
    }
    for(int nb : g[beg])
    {
        if(nb != par[beg])
        {
            par[nb] = beg;
            dfs(nb);
        }
    }
}

int dist(int a, int b)
{
    return sub[a]+sub[b]-2*sub[lca(a,b)];
}

int compa,compb;

bool cmpa(int p1, int p2)
{
    return dist(compa,p1)<dist(compa,p2);
}

bool cmpb(int p1, int p2)
{
    return dist(compb,p1)<dist(compb,p2);
}

void solve(int a, int b)
{
    vector<int>vx,vy;
    vx = v;
    vy = v;

    compa = a;
    compb = b;
    sort(vx.begin(),vx.end(),cmpa);
    sort(vy.begin(),vy.end(),cmpb);
    int ch;
    int ans = 1e9;
    for(int x = 0; x < min(1,(int)vx.size()); x++)
    {
        for(int y = 0; y < min(25,(int)vy.size()); y++)
        {
            par[a] = a;
            cel = vx[x];
            idx = 1;
            dfs(a);

            par[b] = b;
            cel = vy[y];
            idx = 0;
            dfs(b);

            for(int j = 0; j < path[0].size(); j++)
            {
                ch = j;
                for(int i = 1; i < path[1].size(); i++)
                {
                    if(path[0].size()-j-1 < i || dist(path[1][i-1],path[0][i+j-1]) <= dist(path[1][i],path[0][i+j])) ch += 1;
                    else ch += 2;
                }
                if(path[0].size()-j>path[1].size()) ch += (path[0].size()-j-path[1].size());
                ans = min(ans,ch);
            }

            /*for(int j = 0; j < path[1].size(); j++)
            {
                ch = j;
                for(int i = 1; i < path[0].size(); i++)
                {
                    if(path[1].size()-j-1 < i || dist(path[0][i-1],path[1][i+j-1]) <= dist(path[0][i],path[1][i+j])) ch += 1;
                    else ch += 2;
                }
                if(path[1].size()-j>path[0].size()) ch += (path[1].size()-j-path[0].size());
                ans = min(ans,ch);
            }*/
        }
    }


    for(int x = 0; x < min(25,(int)vx.size()); x++)
    {
        for(int y = 0; y < min(1,(int)vy.size()); y++)
        {
            par[a] = a;
            cel = vx[x];
            idx = 1;
            dfs(a);

            par[b] = b;
            cel = vy[y];
            idx = 0;
            dfs(b);

            /*for(int j = 0; j < path[0].size(); j++)
            {
                ch = j;
                for(int i = 1; i < path[1].size(); i++)
                {
                    if(path[0].size()-j-1 < i || dist(path[1][i-1],path[0][i+j-1]) <= dist(path[1][i],path[0][i+j])) ch += 1;
                    else ch += 2;
                }
                if(path[0].size()-j>path[1].size()) ch += (path[0].size()-j-path[1].size());
                ans = min(ans,ch);
            }*/

            for(int j = 0; j < path[1].size(); j++)
            {
                ch = j;
                for(int i = 1; i < path[0].size(); i++)
                {
                    if(path[1].size()-j-1 < i || dist(path[0][i-1],path[1][i+j-1]) <= dist(path[0][i],path[1][i+j])) ch += 1;
                    else ch += 2;
                }
                if(path[1].size()-j>path[0].size()) ch += (path[1].size()-j-path[0].size());
                ans = min(ans,ch);
            }
        }
    }

    cout << ans << endl;
}

void read()
{
    cin >> n >> q;
    for(int i = 1; i <= n; i++) cin >> e[i];
    for(int i = 1; i <= n; i++) if(e[i]) v.push_back(i);

    int a,b;
    for(int i = 1; i < n; i++)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    pre();

    for(int i = 1; i <= q; i++)
    {
        cin >> a >> b;
        solve(a,b);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
