#include "intervals.h"
///#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#include <random>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

int n0;
vector<int> ans;
bool check[MAXN + 5];
int a[MAXN + 5][MAXN + 5];
vector< vector<int> > cliques[MAXN + 5];

int length_intersection(vector<int> indices);

void go(int len)
{
    if (check[len]) return;
    check[len] = true;

    int t = len / 2;
    go(t);
    if (len % 2 and !check[t + 1])
    {
        check[t + 1] = true;
        for (auto v : cliques[t])
        {
            for (int i = 0; i < n0; ++ i)
            {
                if (i > v.back())
                {
                    auto v2 = v;
                    v2.push_back(i);
                    if (length_intersection(v2) > 0) cliques[t + 1].push_back(v2);
                }
            }
        }
    }

    for (auto v : cliques[t])
    {
        for (auto v2 : cliques[len - t])
        {
            if (v.back() >= v2.front()) continue;
            auto v3 = v;
            for (auto x : v2)
            {
                v3.push_back(x);
            }
            if (length_intersection(v3) > 0) cliques[len].push_back(v3);
            if (cliques[len].size() > n0) return;
        }
    }
}

vector<int> max_cardinality_intersection(int n)
{
    n0 = n;

    for (int i = 0; i < n; ++ i)
    {
        cliques[1].push_back({i});
    }

    ans = {0};
    int l = 1, r = n + 1, mid;
    while (r - l > 1)
    {
        mid = (l + r) / 2;
        go(mid);
        if (!cliques[mid].empty())
        {
            l = mid;
            ans = cliques[mid][0];
        }
        else r = mid;
    }
    return ans;
}
