#include <bits/stdc++.h>

using namespace std;

const int maxn = 15005;

int n;
char s[maxn];

short suffix[maxn][maxn];
short preffix[maxn];
short a[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];

        if (s[i] == '(') a[i] = 1;
        else a[i] = -1;
    }

    short balance = 0;

    for (int i = 1; i <= n; ++i)
    {
        balance += a[i];
        preffix[i] = balance;
    }

    for (int i = 1; i <= n; ++i)
    {
        balance = 0;
        balance += a[i];

        suffix[i][i] = balance;

        for (int j = i - 1; j >= 1; --j)
        {
            balance += a[j];
            suffix[j][i] = min(suffix[j + 1][i], balance);
        }
    }

    int ans = n;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= n; ++j)
        {
            if (preffix[i - 1] + suffix[i][j] >= 0)
            {
                //cout << i << " " << j << " :: " << suffix[i][j] << " " << preffix[i - 1] << endl;
                ++ans;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
