#include <bits/stdc++.h>

using namespace std;

const int maxn = 15005;

int n;
char s[maxn];

int preffix[maxn];
int a[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];

        if (s[i] == '(') a[i] = 1;
        else a[i] = -1;
    }

    int balance = 0, minBalance = n;

    for (int i = 1; i <= n; ++i)
    {
        balance += a[i];
        preffix[i] = balance;
    }

    int ans = n;

    for (int i = 1; i <= n; ++i)
    {
        balance = 0;
        balance += a[i];
        minBalance = balance;

        for (int j = i - 1; j >= 1; --j)
        {
            balance += a[j];
            minBalance = min(minBalance, balance);

            if (preffix[j - 1] + minBalance >= 0)
            {
                ++ans;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
